import ddf.minim.*;
import ddf.minim.analysis.*;

Minim minim;
AudioInput in;
FFT fft;
String note; 
float hertz; 
float midi; 
int noteNumber; 


int sampleRate= 44100; 

float [] max= new float [sampleRate/2];
float maximum;
float frequency;

PImage playing;
PImage pleasePlay;
PImage dunnoPlay;

int playThis;
int startNote;
int minNote;
int maxNote;
int range;
int correctNotes;
int currentlyPlaying;


void setup()
{
  size(1056, 900);

  playing  = loadImage("dunno.png");
  dunnoPlay = loadImage("dunno.png");
  minim = new Minim(this);
  minim.debugOn();
  in = minim.getLineIn(Minim.MONO, 4096*2, sampleRate);
  fft = new FFT(in.left.size(), sampleRate);

  textSize(50);  
  fill(0);


  minNote = 57; 
  maxNote  =85; 
  range =4;
  correctNotes=0;
  startNote = 60;
  playThis = startNote;
  playThis = getNewGuessNote();


  pleasePlay  = loadImage(getNotename(playThis));
}

//261 hz = c4

int getNewGuessNote()
{

  int  toreturn =  playThis;

  while (toreturn ==  playThis ) 
  {
    toreturn =  startNote+int( random(-range/2.0, range/2.0));
  }


  if (getNotename(toreturn).contains("#") )
  {
    toreturn++;
  }

  return toreturn;
}

void draw()
{


  background(255);//black BG
  image(pleasePlay, 10, 200);


  image(dunnoPlay, 533, 200);

  if (playing != null)
  {
    image(playing, 533, 200);
  }

  if (findNote())
  {
    text (frequency+" hz" + " note:"+note, 50, 80);//display the frequency in hertz
  }
  text ("correct: "+ correctNotes, 50, 80+50);

  if (currentlyPlaying == playThis)
  {
    correctNotes++;
    range++;
    playThis = getNewGuessNote();
    println("playThis:" + playThis );

    pleasePlay  = loadImage(getNotename(playThis));
  }
}



float MIDItoFreq( int keynum ) 
{ 
  return 440.0 * pow( 2.0, ((float)keynum - 69.0) / 12.0 );
} 

int find(float frequency)
{

  for (int i = 10; i < 127; i++)
  {

    if (int(MIDItoFreq(i)) == int(frequency))
    {
      return i;
    }
  }

  int found =0;

  float closest = MIDItoFreq(10);
  for ( int i = 10; i < 127; ++i ) {
    if ( abs( MIDItoFreq( i) - frequency ) < abs( closest - frequency ) ) 
    {
      closest = MIDItoFreq(i);
      found =i;
    }
  }

 return found;
}


String getNotename(int n)
{

  switch(n%12)
  {
   case 9: 
    note = ("a");
    break;
  case 10: 
    note = ("a#");
    break;
  case 11:
    note = ("b");
    break;
  case 0:
    note = ("c");
    break;
  case 1:
    note = ("c#");
    break;
  case 2:
    note = ("d");
    break;
  case 3:
    note = ("d#");
    break;
  case 4:
    note = ("e");
  case 5:
    note = ("f");
    break;
  case 6:
    note = ("f#");
    break;
  case 7:
    note = ("g");
    break;
  case 8:
    note = ("g#");
    break;
  }
  int octave =  ((n/12)-1);
 
  return note+octave+".png";
}


boolean findNote() {

  fft.forward(in.left);

  float maxfreq=0;
  maximum =0;
  for (int i = 0; i < fft.specSize (); i++)
  {

    if (fft.getBand(i)>maximum)
    {
      maximum = fft.getBand(i);
      maxfreq = i;
    }
  }
  frequency = maxfreq*0.5*sampleRate/fft.specSize();
  frequency-=1.21524;
  if (maximum < 10)
  {
    return false;
  }


  midi=find(frequency);

  currentlyPlaying= int (midi); 
  try {
    if( (currentlyPlaying >  minNote)  &&  currentlyPlaying  < maxNote)
    playing  = loadImage(getNotename(currentlyPlaying)); 
  }
  catch(Exception e)
  {
  }

  return true;
}

void stop()
{
  // always close Minim audio classes when you are done with them
  in.close();
  minim.stop();

  super.stop();
}

